=== debian/changelog ===
openbabel (2.3.2+dfsg-3build1) artful; urgency=medium

  * No-change rebuild for perl 5.26.0.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jul 2017 20:11:55 +0000
