=== debian/watch ===
# See uscan(1) for format

version=3
opts=dversionmangle=s/\+dfsg$// \
 http://sf.net/openbabel/openbabel-([\d\.]+)\.tar\.gz \
 debian /bin/sh debian/get-orig-source.sh
